#Import Modules
import os, pygame
from pygame.locals import *

from menu import Menu
from scene import Scene
from player import Player

from helper import *

class Game:
    def __init__(self):
    #Initialize Everything
        pygame.init()
        pygame.mixer.init()
        self.screen = pygame.display.set_mode((640, 480))
        pygame.display.set_caption('Death Tower     Cthulhu32  \'07 Pyweek #4')
        pygame.mouse.set_visible(0)

    #Prepare Game Objects
        self.clock = pygame.time.Clock()
        self.curPlayer = Player()

    def Run(self):
        # fade from black to our intro
        background = pygame.Surface(self.screen.get_size())
        background.fill((0, 0, 0))
        background.set_alpha(255)

        load_music('introNoise.ogg')
        pygame.mixer.music.play()
        
        intro, null = load_image('cthulhu32logo1.gif')
        fadeCount = 0
        introCount = 0
        
        #Intro Loop
        while 1:
            self.clock.tick(60)

            
        #Handle Input Events
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        return
                    elif event.key == K_RETURN:
                        fadeCount = 60
                        introCount = 360

            # 1 second fade in
            if fadeCount < 40:
                background.set_alpha(255-fadeCount*8)
                self.screen.blit(intro, (0, 0))
                self.screen.blit(background, (0, 0))
                pygame.display.flip()
                fadeCount = fadeCount + 1
                continue
            elif fadeCount == 40:
                fadeCount = fadeCount + 1
                self.screen.blit(intro, (0, 0))
                pygame.display.flip()
                        
            # 6 second intro totally skippable by user
            if introCount < 240:
                introCount = introCount + 1
            else:
                break

        pygame.mixer.music.stop()

        while 1:
            startMenu = Menu()
            menuImage,null = load_image('titlescreen1.gif')
            helpImage,null = load_image('howto1.gif')
            startMenu.setMenuBG(menuImage)
            startMenu.setMenuBG(helpImage)
            startMenu.setOptions(2)
            startMenu.setCursorOffset((155,228),0)
            startMenu.setCursorOffset((155,300),1)

            startMenu.setCursorOffset((550,430),2)

            load_music('gothicSong.ogg')
            pygame.mixer.music.play(-1)
            gameLogic = 0
            gameSel = 0
            #Menu Loop
            while 1:
                self.clock.tick(60)

            #Handle Input Events
                for event in pygame.event.get():
                    if event.type == QUIT:
                        return
                    elif event.type == KEYDOWN:
                        if event.key == K_ESCAPE:
                            return
                        elif event.key == K_DOWN:
                            if gameLogic == 0:
                                startMenu.moveDown()
                            gameSel = (gameSel + 1) % 2
                        elif event.key == K_UP:
                            if gameLogic == 0:
                                startMenu.moveUp()
                            gameSel = (gameSel - 1) % 2
                        elif event.key == K_RETURN:
                            if gameSel == 0 and gameLogic == 0:
                                gameLogic = 1 #this should be a menu command
                            elif gameSel == 1:
                                gameLogic = 2

                if gameLogic == 1:
                    break
                elif gameLogic == 2:
                    startMenu.changebg()
                    gameLogic = 0
                    gameSel = 0
                startMenu.display(self.screen)

            pygame.mixer.music.stop()
            gameScene = Scene(self.curPlayer, 0) # start at level 0

            load_music('battleSong.ogg')
            pygame.mixer.music.play(-1)

            #In-Game Loop
            while 1:
                self.clock.tick(60)

                if gameScene.update() == 1:
                    break # we quit the gamescene
                gameScene.display(self.screen)

            pygame.mixer.music.stop()
                        
