#Import Modules
import os, pygame
from pygame.locals import *

from helper import *
from level import Level

class Player(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image,self.rect = load_image('warriorB1.gif',-1) #this is to get the 32x32 rect
        self.posx = 40.0
        self.posy = 40.0
        self.oldx = self.posx
        self.oldy = self.posy
        self.rect.topleft = self.posx, self.posy
        self.worldx = 0
        self.worldy = 0
        self.worldmaxx = 0
        self.worldmaxy = 0
        self.speed = 5.0

        self.life = 300
        self.lifemax = 300
        self.collideDamage = 20 # how much damage you do when you contact enemies
    
        # DEBUG !!!
        self.redkey = 0
        self.bluekey = 0
        #

        self.edge = 32 #when this is made huge, something messes up, fix later
        self.posyMax = 480 - self.edge
        self.posxMax = 640 - self.edge
        self.worldyMax = self.posyMax - 32
        self.worldxMax = self.posxMax - 32
        
        self.frameCount = 0
        self.state = 0 # 0 = stand, 1 = move, 2 = move up a tower!, 3 = dead!
        self.alive = 1 # 1 = alive, 0 = dead
        self.direction = 0 # 0 = bottom, 1 = bottomright, 2 = right, 3 = topright
                           # 4 = top, 5 = topleft, 6 = left, 7 = bottomleft

        #lets setup initial images for player
        self.runB = []
        runB1, null = load_image('warriorB1.gif',-1)
        runB2, null = load_image('warriorB2.gif',-1)
        self.runB.append(runB1)
        self.runB.append(runB2)

        self.runBR = []
        runBR1, null = load_image('warriorBR1.gif',-1)
        runBR2, null = load_image('warriorBR2.gif',-1)
        self.runBR.append(runBR1)
        self.runBR.append(runBR2)

        self.runR = []
        runR1, null = load_image('warriorR1.gif',-1)
        runR2, null = load_image('warriorR2.gif',-1)
        self.runR.append(runR1)
        self.runR.append(runR2)

        self.runTR = []
        runTR1, null = load_image('warriorTR1.gif',-1)
        runTR2, null = load_image('warriorTR2.gif',-1)
        self.runTR.append(runTR1)
        self.runTR.append(runTR2)

        self.runT = []
        runT1, null = load_image('warriorT1.gif',-1)
        runT2, null = load_image('warriorT2.gif',-1)
        self.runT.append(runT1)
        self.runT.append(runT2)

        self.runTL = []
        runTL1 = pygame.transform.flip(runTR1,1,0)
        runTL2 = pygame.transform.flip(runTR2,1,0)
        self.runTL.append(runTL1)
        self.runTL.append(runTL2)

        self.runL = []
        runL1 = pygame.transform.flip(runR1,1,0)
        runL2 = pygame.transform.flip(runR2,1,0)
        self.runL.append(runL1)
        self.runL.append(runL2)

        self.runBL = []
        runBL1 = pygame.transform.flip(runBR1,1,0)
        runBL2 = pygame.transform.flip(runBR2,1,0)
        self.runBL.append(runBL1)
        self.runBL.append(runBL2)
        # all 8 positions have been updated, woop

    def update(self, curLevel):
        if self.state == 1:
            if self.frameCount == 0:        # frame 0
                if self.direction == 0:
                    self.image = self.runB[0]
                elif self.direction == 1:
                    self.image = self.runBR[0]
                elif self.direction == 2:
                    self.image = self.runR[0]
                elif self.direction == 3:
                    self.image = self.runTR[0]
                elif self.direction == 4:
                    self.image = self.runT[0]
                elif self.direction == 5:
                    self.image = self.runTL[0]
                elif self.direction == 6:
                    self.image = self.runL[0]
                elif self.direction == 7:
                    self.image = self.runBL[0]
            elif self.frameCount == 10:     # frame 1
                if self.direction == 0:
                    self.image = self.runB[1]
                elif self.direction == 1:
                    self.image = self.runBR[1]
                elif self.direction == 2:
                    self.image = self.runR[1]
                elif self.direction == 3:
                    self.image = self.runTR[1]
                elif self.direction == 4:
                    self.image = self.runT[1]
                elif self.direction == 5:
                    self.image = self.runTL[1]
                elif self.direction == 6:
                    self.image = self.runL[1]
                elif self.direction == 7:
                    self.image = self.runBL[1]
            self.frameCount = (self.frameCount + 1) % 20
            self.playerCollide(curLevel)
            self.oldx = self.oldx - (self.posx + self.worldx)
            self.oldy = self.oldy - (self.posy + self.worldy)
            self.rect.topleft = (int(self.posx), int(self.posy))
        if self.alive == 0:
            self.state = 3
        return self.state
            

    def playerCollide(self, level):
        #debug
        totalx = self.posx + self.worldx
        totaly = self.posy + self.worldy
        self.oldx = totalx
        self.oldy = totaly
        extra = int(self.speed)
        if self.direction == 0:
            # check for wall!
            bottom = []
            for i in range(0+extra,32-extra):
                bottom.append(level.tileAt(totalx+i,totaly+32+extra))
                                # one more than character's 32x32
            if 'W' in bottom:      # for now, we had a wall, do not move
                return
            elif 'R' in bottom:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+32)
                else:
                    return
            elif 'B' in bottom:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+32)
                else:
                    return
            elif 'U' in bottom:
                self.state = 2
            
            if self.posy >= self.worldyMax:
                if self.worldy < self.worldmaxy:
                    self.worldy += self.speed
                else:
                    if self.posy <= self.posyMax:
                        self.posy += self.speed
            else:
                self.posy += self.speed
        elif self.direction == 1:
            # check for wall!
            bottom = []
            for i in range(0+extra,32-extra):
                bottom.append(level.tileAt(totalx+i,totaly+32+extra))
                                # one more than character's 32x32
            if 'W' not in bottom:      # for now, we had a wall, do not move
                if self.posy >= self.worldyMax:
                    if self.worldy < self.worldmaxy:
                        self.worldy += self.speed * 0.7
                    else:
                        if self.posy <= self.posyMax:
                            self.posy += self.speed * 0.7
                else:
                    self.posy += self.speed * 0.7
            elif 'R' in bottom:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+32)
                else:
                    return
            elif 'B' in bottom:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+32)
                else:
                    return
            elif 'U' in bottom:
                self.state = 2
            # check for wall!
            right = []
            for i in range(0+extra,16-extra):
                right.append(level.tileAt(totalx+32+extra,totaly+16+i))
                                # one more than character's 32x32
            if 'W' in right:      # for now, we had a wall, do not move
                return
            elif 'R' in right:
                if self.redkey == 1:
                    level.removeDoor(totalx+32,totaly+16)
                else:
                    return
            elif 'B' in right:
                if self.bluekey == 1:
                    level.removeDoor(totalx+32,totaly+16)
                else:
                    return
            elif 'U' in right:
                self.state = 2
            if self.posx >= self.worldxMax:
                if self.worldx < self.worldmaxx:
                    self.worldx += self.speed * 0.7
                else:
                    if self.posx <= self.posxMax:
                        self.posx += self.speed * 0.7
            else:
                self.posx += self.speed * 0.7
        elif self.direction == 2:
            # check for wall!
            right = []
            for i in range(0+extra,16-extra):
                right.append(level.tileAt(totalx+32+extra,totaly+16+i))
                                # one more than character's 32x32
            if 'W' in right:      # for now, we had a wall, do not move
                return
            elif 'R' in right:
                if self.redkey == 1:
                    level.removeDoor(totalx+32,totaly+16)
                else:
                    return
            elif 'B' in right:
                if self.bluekey == 1:
                    level.removeDoor(totalx+32,totaly+16)
                else:
                    return
            elif 'U' in right:
                self.state = 2
            if self.posx >= self.worldxMax:
                if self.worldx < self.worldmaxx:
                    self.worldx += self.speed
                else:
                    if self.posx <= self.posxMax:
                        self.posx += self.speed
            else:
                self.posx += self.speed
        elif self.direction == 3:
            # check for wall above character
            top = []
            for i in range(0+extra,32-extra):
                top.append(level.tileAt(totalx+i,totaly+16-extra))
                                # one more than character's 32x32
            if 'W' not in top:      # for now, we had a wall, do not move
                if self.posy <= self.edge:
                    if self.worldy > 0:
                        self.worldy -= self.speed * 0.7
                    else:
                        if self.posy > 2:
                            self.posy -= self.speed * 0.7
                else:
                    self.posy -= self.speed * 0.7
            elif 'R' in top:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'B' in top:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'U' in top:
                self.state = 2
            # check for wall!
            right = []
            for i in range(0+extra,16-extra):
                right.append(level.tileAt(totalx+32+extra,totaly+16+i))
                                # one more than character's 32x32
            if 'W' in right:      # for now, we had a wall, do not move
                return
            elif 'R' in right:
                if self.redkey == 1:
                    level.removeDoor(totalx+32,totaly+16)
                else:
                    return
            elif 'B' in right:
                if self.bluekey == 1:
                    level.removeDoor(totalx+32,totaly+16)
                else:
                    return
            elif 'U' in right:
                self.state = 2
            if self.posx >= self.worldxMax:
                if self.worldx < self.worldmaxx:
                    self.worldx += self.speed * 0.7
                else:
                    if self.posx <= self.posxMax:
                        self.posx += self.speed * 0.7
            else:
                self.posx += self.speed * 0.7
        elif self.direction == 4:
            # check for wall above character
            top = []
            for i in range(0+extra,32-extra):
                top.append(level.tileAt(totalx+i,totaly+16-extra))
                                # one more than character's 32x32
            if 'W' in top:      # for now, we had a wall, do not move
                return
            elif 'R' in top:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'B' in top:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'U' in top:
                self.state = 2
            if self.posy <= self.edge:
                if self.worldy > 0:
                    self.worldy -= self.speed
                else:
                    if self.posy > 2:
                        self.posy -= self.speed
            else:
                self.posy -= self.speed
        elif self.direction == 5:
            # check for wall above character
            top = []
            for i in range(0+extra,32-extra):
                top.append(level.tileAt(totalx+i,totaly+16-extra))
                                # one more than character's 32x32
            if 'W' not in top:      # for now, we had a wall, do not move
                if self.posy <= self.edge:
                    if self.worldy > 0:
                        self.worldy -= self.speed * 0.7
                    else:
                        if self.posy > 2:
                            self.posy -= self.speed * 0.7
                else:
                    self.posy -= self.speed * 0.7
            elif 'R' in top:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'B' in top:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'U' in top:
                self.state = 2
            # check for wall!
            left = []
            for i in range(0+extra,16-extra):
                left.append(level.tileAt(totalx-extra,totaly+16+i))
                                # one more than character's 32x32
            if 'W' in left:      # for now, we had a wall, do not move
                return
            elif 'R' in left:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'B' in left:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            #elif 'U' in left:
                #print "we found the next room!"
            if self.posx <= self.edge:
                if self.worldx > 0:
                    self.worldx -= self.speed * 0.7
                else:
                    if self.posx > 2:
                        self.posx -= self.speed * 0.7
            else:
                self.posx -= self.speed * 0.7
        elif self.direction == 6:
            left = []
            for i in range(0+extra,16-extra):
                left.append(level.tileAt(totalx-extra,totaly+16+i))
                                # one more than character's 32x32
            if 'W' in left:      # for now, we had a wall, do not move
                return
            elif 'R' in left:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'B' in left:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'U' in left:
                self.state = 2
            if self.posx <= self.edge:
                if self.worldx > 0:
                    self.worldx -= self.speed
                else:
                    if self.posx > 2:
                        self.posx -= self.speed
            else:
                self.posx -= self.speed
        elif self.direction == 7:
            # check for wall!
            bottom = []
            for i in range(0+extra,32-extra):
                bottom.append(level.tileAt(totalx+i,totaly+32+extra))
                                # one more than character's 32x32
            if 'W' not in bottom:      # for now, we had a wall, do not move
                if self.posy >= self.worldyMax:
                    if self.worldy < self.worldmaxy:
                        self.worldy += self.speed * 0.7
                    else:
                        if self.posy < self.posyMax:
                            self.posy += self.speed * 0.7
                else:
                    self.posy += self.speed * 0.7
            elif 'R' in bottom:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+32)
                else:
                    return
            elif 'B' in bottom:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+32)
                else:
                    return
            elif 'U' in bottom:
                self.state = 2
            left = []
            for i in range(0+extra,16-extra):
                left.append(level.tileAt(totalx-extra,totaly+16+i))
                                # one more than character's 32x32
            if 'W' in left:      # for now, we had a wall, do not move
                return
            elif 'R' in left:
                if self.redkey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'B' in left:
                if self.bluekey == 1:
                    level.removeDoor(totalx,totaly+16)
                else:
                    return
            elif 'U' in left:
                self.state = 2
            if self.posx <= self.edge:
                if self.worldx > 0:
                    self.worldx -= self.speed * 0.7
                else:
                    if self.posx > 2:
                        self.posx -= self.speed * 0.7
            else:
                self.posx -= self.speed * 0.7

    def moveB(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 0
        elif self.direction == 2:
            self.direction = 1
        elif self.direction == 6:
            self.direction = 7

    def moveR(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 2
        elif self.direction == 0:
            self.direction = 1
        elif self.direction == 4:
            self.direction = 3

    def moveT(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 4
        elif self.direction == 2:
            self.direction = 3
        elif self.direction == 6:
            self.direction = 5

    def moveL(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 6
        elif self.direction == 4:
            self.direction = 5
        elif self.direction == 0:
            self.direction = 7

    def stopB(self):
        if self.direction == 7:
            self.direction = 6
        elif self.direction == 1:
            self.direction = 2
        else:
            self.state = 0

    def stopR(self):
        if self.direction == 3:
            self.direction = 4
        elif self.direction == 1:
            self.direction = 0
        else:
            self.state = 0

    def stopT(self):
        if self.direction == 3:
            self.direction = 2
        elif self.direction == 5:
            self.direction = 6
        else:
            self.state = 0

    def stopL(self):
        if self.direction == 5:
            self.direction = 4
        elif self.direction == 7:
            self.direction = 0
        else:
            self.state = 0

    def setPos(self, x, y):
        #print "Setting Player to POS " + str(x) + ", " + str(y)
        if x > 640-32:
            #print "X greater than 640-32, setting to " + str(x-self.worldmaxx)            
            #print "and settings worldx to " + str(x-640)
            self.posx = x - self.worldmaxx
            self.worldx = x - self.posx
        else:
            self.posx = x
        if y > 480-32:
            #print "Y greater than 480-32, setting to " + str(y-self.worldmaxy)
            #print "and settings worldx to " + str(y-480)
            self.posy = y - self.worldmaxy
            self.worldy = y - self.posy
        else:
            self.posy = y
        self.rect.topleft = self.posx, self.posy
        
    #define our max X & Y for a world set
    def setMax(self, maxX, maxY):
        self.worldmaxx = maxX-642
        self.worldmaxy = maxY-482

    def collisionDamage(self, amount):
        self.life = self.life - amount
        #print "Current Life = " + str(self.life)
        if self.life < 0:
            self.state = 3
            self.alive = 0
        if self.state > 0:
            self.state = 0
            self.posx = self.posx + self.oldx
            self.posy = self.posy + self.oldy
            self.oldx = 0
            self.oldy = 0

    def addItem(self, item):
        if item == "RedKey":
            #print "Acquired the Red Key!"
            self.redkey = 1
        elif item == "BlueKey":
            #print "Acquired the Blue Key!"
            self.bluekey = 1
        elif item == "Meat":
            #print "Acquired Some Meat, adding +50 health!"
            self.life = self.life + 150
            if self.life > self.lifemax:
                self.life = self.lifemax

    def getworldX(self):
        return self.worldx

    def getworldY(self):
        return self.worldy

    def getX(self):
        return self.posx + self.worldx

    def getY(self):
        return self.posy + self.worldy

    def getDir(self):
        return self.direction

    def dealCollide(self):
        return self.collideDamage
