#Import Modules
import os, pygame, random
from pygame.locals import *

from helper import *
from level import Level

class Projectile(pygame.sprite.Sprite):
    def __init__(self, newDir, x, y, maxx, maxy):
        pygame.sprite.Sprite.__init__(self)
        self.image, self.rect = load_image('throwDagS1.gif',-1)
        self.imageL = []
        
        # just incase
        self.worldmaxx = maxx
        self.worldmaxy = maxy

        self.damage = 0         #placeholders
        self.speed  = 1.0       #placeholders
        self.frameCount = 0
        self.numFrames = 1
        self.direction = newDir
        self.posx = x
        self.posy = y
        self.lifeCount = 1 #how long the projectile lasts

    def update(self, level, worldx, worldy, spriteList):
        self.frameCount = (self.frameCount + 1) % (self.numFrames*10)
        if self.frameCount % 10 == 0:
            self.image = self.imageL[self.frameCount/10]
        totalx = self.posx
        totaly = self.posy
        extra = 1

        if self.lifeCount > 0:
            self.lifeCount = self.lifeCount - 1
        else:
            spriteList.remove(self)
            self.lifeCount = 60
            
        if self.direction == 0:
            # check for wall!
            bottom = []
            for i in range(0+extra,16-extra):
                bottom.append(level.tileAt(totalx+i,totaly+16+extra))
                                # one more than projectile's 16x16
            if 'W' in bottom:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posy < self.worldmaxy:
                self.posy += self.speed
        elif self.direction == 1:
            # check for wall!
            bottom = []
            for i in range(0+extra,16-extra):
                bottom.append(level.tileAt(totalx+i,totaly+32+extra))
                                # one more than character's 32x32
            if 'W' not in bottom:      # for now, we had a wall, do not move
                if self.posy < self.worldmaxy:        
                    self.posy += self.speed * 0.7
            else:
                spriteList.remove(self)
            # check for wall!
            right = []
            for i in range(0+extra,8-extra):
                right.append(level.tileAt(totalx+16+extra,totaly+8+i))
                                # one more than character's 32x32
            if 'W' in right:      # for now, we had a wall, do not move
                spriteList.remove(self)
            
            if self.posx < self.worldmaxx:
                self.posx += self.speed * 0.7
        elif self.direction == 2:
            # check for wall!
            right = []
            for i in range(0+extra,8-extra):
                right.append(level.tileAt(totalx+16+extra,totaly+8+i))
                                # one more than character's 32x32
            if 'W' in right:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posx < self.worldmaxx:
                self.posx += self.speed
        elif self.direction == 3:
            # check for wall above character
            top = []
            for i in range(0+extra,16-extra):
                top.append(level.tileAt(totalx+i,totaly+8-extra))
                                # one more than character's 32x32
            if 'W' not in top:      # for now, we had a wall, do not move
                if self.posy > 0:
                    self.posy -= self.speed * 0.7
            else:
                spriteList.remove(self)
            # check for wall!
            right = []
            for i in range(0+extra,8-extra):
                right.append(level.tileAt(totalx+16+extra,totaly+8+i))
                                # one more than character's 32x32
            if 'W' in right:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posx < self.worldmaxx:
                self.posx += self.speed * 0.7
        elif self.direction == 4:
            # check for wall above character
            top = []
            for i in range(0+extra,16-extra):
                top.append(level.tileAt(totalx+i,totaly+8-extra))
                                # one more than character's 32x32
            if 'W' in top:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posy > 0:
                self.posy -= self.speed
        elif self.direction == 5:
            # check for wall above character
            top = []
            for i in range(0+extra,16-extra):
                top.append(level.tileAt(totalx+i,totaly+8-extra))
                                # one more than character's 32x32
            if 'W' not in top:      # for now, we had a wall, do not move
                if self.posy > 0:
                    self.posy -= self.speed * 0.7
            else:
                spriteList.remove(self)
            # check for wall!
            left = []
            for i in range(0+extra,8-extra):
                left.append(level.tileAt(totalx-extra,totaly+8+i))
                                # one more than character's 32x32
            if 'W' in left:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posx > 0:
                self.posx -= self.speed * 0.7
        elif self.direction == 6:
            left = []
            for i in range(0+extra,8-extra):
                left.append(level.tileAt(totalx-extra,totaly+8+i))
                                # one more than character's 32x32
            if 'W' in left:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posx > 0:
                self.posx -= self.speed
        elif self.direction == 7:
            # check for wall!
            bottom = []
            for i in range(0+extra,16-extra):
                bottom.append(level.tileAt(totalx+i,totaly+16+extra))
                                # one more than character's 32x32
            if 'W' not in bottom:      # for now, we had a wall, do not move
                if self.posy < self.worldmaxy:
                    self.posy += self.speed * 0.7
            else:
                spriteList.remove(self)
            left = []
            for i in range(0+extra,8-extra):
                left.append(level.tileAt(totalx-extra,totaly+8+i))
                                # one more than character's 32x32
            if 'W' in left:      # for now, we had a wall, do not move
                spriteList.remove(self)
            if self.posx > 0:
                self.posx -= self.speed * 0.7
        self.rect.topleft = (int(self.posx)-worldx, int(self.posy)-worldy)

    def getDamage(self):
        return self.damage

#lets add some projectiles
class flyingDagger(Projectile):
    def __init__(self, newDir, x, y, maxx, maxy):
        Projectile.__init__(self,newDir,x,y,maxx,maxy)

        image1,null = load_image('throwDagS1.gif',-1)
        image2,null = load_image('throwDagS2.gif',-1)
        image3,null = load_image('throwDagS3.gif',-1)
        image4,null = load_image('throwDagS4.gif',-1)
        # this will be defined in a different location later
        self.imageL.append(image1)
        self.imageL.append(image2)
        self.imageL.append(image3)
        self.imageL.append(image4)

        self.numFrames = 4
        self.speed = 8.0
        self.damage = 50
        self.lifeCount = 60
