#Import Modules
import os, pygame
from pygame.locals import *

from player import Player
from monster import *
from projectile import *
from level import Level
from helper import *

class Scene:
    def __init__(self, player, levelcnt):
        self.aliveState = 1 # still alive
        # CHANGE THIS AT SOME POINT!!!!!!! -------------------
        if levelcnt > 6:        # a quick way to say you win
            self.levelcnt = 6
            self.aliveState = 0
        # -- temp : HEALTH BAR --
        self.healthBar, null = load_image('healthBar1.gif',-1)
        self.healthBarI, null = load_image('healthBar1inside.gif')
        self.gameover, null = load_image('gameover.gif')
        # -- end temp --
        self.player = player
        self.playersprites = pygame.sprite.RenderPlain((self.player))
        self.monstersprites = pygame.sprite.RenderPlain(())
        self.itemsprites = pygame.sprite.RenderPlain(())
        self.projectilesprites = pygame.sprite.RenderPlain(())
        self.currentLevel = Level()
        self.levelCount = levelcnt
        #setting maxes
        # -------- LOAD LEVEL --------
        playerStartX, playerStartY, self.playerMaxX, self.playerMaxY = self.currentLevel.loadLevel(self.levelCount, self.monstersprites, self.itemsprites)
        # ------- Level Loaded -------
        self.player.setMax(self.playerMaxX,self.playerMaxY)
        self.player.setPos(playerStartX, playerStartY)
        for m in self.monstersprites:
            m.setMax(self.playerMaxX,self.playerMaxY)

    def update(self):
        if self.aliveState == 0:
            for event in pygame.event.get():
                if event.type == QUIT:
                    return 1
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE or event.key == K_RETURN:
                        return 1 # exit out of current scene!
            # --- UPDATING MONSTERS --- #
            self.monstersprites.update(self.currentLevel,int(self.player.getworldX()),int(self.player.getworldY()),int(self.player.getX()),int(self.player.getY()))
            #----- thanks Feakk for the following code -----
            # --- CHECKING MONSTER VS MONSTER COLLISIONS --- #
            for e1, elist in pygame.sprite.groupcollide(self.monstersprites, self.monstersprites, 0, 0).iteritems():# monster vs monster
                for e2 in elist:
                    if e1 == e2:
                        break
                    else:
                        null = 0
                        e1.collisionHalt(int(self.player.getworldX()), int(self.player.getworldY()))
                        e2.collisionHalt(int(self.player.getworldX()), int(self.player.getworldY()))
                        # monsters are hitting each other
        elif self.aliveState == 1:
            #sprites will update
            for event in pygame.event.get():
                if event.type == QUIT:
                    return 1
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        return 1 # exit out of current scene!
                    elif event.key == K_DOWN:
                        self.player.moveB()
                    elif event.key == K_RIGHT:
                        self.player.moveR()
                    elif event.key == K_UP:
                        self.player.moveT()
                    elif event.key == K_LEFT:
                        self.player.moveL()
                    elif event.key == K_SPACE:
                        self.projectilesprites.add(flyingDagger(self.player.getDir(),self.player.getX()+8,self.player.getY()+12,self.playerMaxX,self.playerMaxY))
                elif event.type == KEYUP:
                    if event.key == K_DOWN:
                        self.player.stopB()
                    elif event.key == K_RIGHT:
                        self.player.stopR()
                    elif event.key == K_UP:
                        self.player.stopT()
                    elif event.key == K_LEFT:
                        self.player.stopL()
            # --- UPDATING PLAYER --- #
            #for player in self.playersprites.update(self.currentLevel):
            #    self.levelup()
            tmp = self.player.update(self.currentLevel)
            if tmp == 2:
                self.levelup()
            elif tmp == 3:
                self.aliveState = 0
                #print "no longer alive"
            # --- CHECKING PLAYER VS MONSTER COLLISIONS --- #
            for p1, mlist in pygame.sprite.groupcollide(self.playersprites, self.monstersprites, 0, 0).iteritems(): #player vs monster
                for m in mlist:
                    p1.collisionDamage(m.collisionDamage(p1.dealCollide(),self.monstersprites))
            # --- UPDATING MONSTERS --- #
            self.monstersprites.update(self.currentLevel,int(self.player.getworldX()),int(self.player.getworldY()),int(self.player.getX()),int(self.player.getY()))
            # --- This is done twice because you want to check (1) after the player moves (2) after the monster moves
            for p1, mlist in pygame.sprite.groupcollide(self.playersprites, self.monstersprites, 0, 0).iteritems(): #player vs monster
                for m in mlist:
                    p1.collisionDamage(m.collisionDamage(p1.dealCollide(),self.monstersprites))
                    m.collisionHalt(int(self.player.getworldX()), int(self.player.getworldY())) #tells monster not to move
            # --- UPDATING PROJECTILES --- #
            self.projectilesprites.update(self.currentLevel,int(self.player.getworldX()),int(self.player.getworldY()),self.projectilesprites)
            #----- Feakk ultimately helped me get this code as well -----
            for m1, plist in pygame.sprite.groupcollide(self.monstersprites, self.projectilesprites, 0, 1).iteritems(): #monster vs projectiles
                for p in plist:
                    m1.damage(p.getDamage(),self.monstersprites)
            #----- thanks Feakk for the following code -----
            # --- CHECKING MONSTER VS MONSTER COLLISIONS --- #
            for e1, elist in pygame.sprite.groupcollide(self.monstersprites, self.monstersprites, 0, 0).iteritems():# monster vs monster
                for e2 in elist:
                    if e1 == e2:
                        break
                    else:
                        null = 0
                        e1.collisionHalt(int(self.player.getworldX()), int(self.player.getworldY()))
                        e2.collisionHalt(int(self.player.getworldX()), int(self.player.getworldY()))
                        # monsters are hitting each other
            # --- UPDATING ITEMS --- #
            self.itemsprites.update(int(self.player.getworldX()),int(self.player.getworldY()))
            for p, ilist in pygame.sprite.groupcollide(self.playersprites, self.itemsprites, 0, 1).iteritems(): #monster vs projectiles
                for i in ilist:
                    p.addItem(i.getItem())
        return 0 #everything is OK '0'

    def display(self, screen):
        if self.aliveState == 0:
            self.currentLevel.draw(screen, int(self.player.getworldX()), int(self.player.getworldY()))
            self.itemsprites.draw(screen)
            self.monstersprites.draw(screen)
            screen.blit(self.healthBar, (3,5))
            screen.blit(self.gameover, (120, 120))
        if self.aliveState == 1:
            self.currentLevel.draw(screen, int(self.player.getworldX()), int(self.player.getworldY()))
            self.itemsprites.draw(screen)
            self.monstersprites.draw(screen)
            self.playersprites.draw(screen)
            self.projectilesprites.draw(screen)
            screen.blit(self.healthBar, (3,5))
            if int(184*(float(self.player.life)/self.player.lifemax)) > 0:
                screen.blit(pygame.transform.scale(self.healthBarI,(int(184*(float(self.player.life)/self.player.lifemax)),8)), (7,9))
        pygame.display.flip()

    def levelup(self):
        #print "Scene: Leevling up!"
        nextLevel = self.levelCount + 1
        self.player.__init__()
        self.__init__(self.player,nextLevel)
